from twisted.web import server, resource
from twisted.internet import reactor

cdef char*(*renderGETCallback)(long)
renderHandlers = {}

cdef public void register_render_get(char*(*cb)(long)):
    global renderGETCallback
    renderGETCallback = cb

class HelloResource(resource.Resource):
    isLeaf = True
    numberRequests = 0
    
    def render_GET(self, request):
        hd = id(request)
        renderHandlers[hd] = request
        ret = renderGETCallback(hd)
        del renderHandlers[hd]
        return ret
        #self.numberRequests += 1
        #request.setHeader("content-type", "text/plain")
        #return "I am request #" + str(self.numberRequests) + "\n"

cdef public void twisted_start():
    reactor.listenTCP(8080, server.Site(HelloResource()))
    reactor.run()
